diff -urN linux.store/linux/Makefile linux/Makefile
--- linux.store/linux/Makefile	Sun Feb 11 13:47:34 1996
+++ linux/Makefile	Mon Mar 11 21:10:39 1996
@@ -137,7 +137,7 @@
 		$(LIBS) -o vmlinux
 	$(NM) vmlinux | grep -v '\(compiled\)\|\(\.o$$\)\|\( a \)\|\( A \)\|\( t L\)' | sort > System.map
 
-symlinks:
+symlinks::
 	rm -f include/asm
 	( cd include ; ln -sf asm-$(ARCH) asm)
 
diff -urN linux.store/linux/README.arm linux/README.arm
--- linux.store/linux/README.arm	Thu Jan  1 01:00:00 1970
+++ linux/README.arm	Tue Mar 12 23:47:01 1996
@@ -0,0 +1,35 @@
+ARM Linux 1.3.35
+----------------
+
+In order to compile ARM Linux, you will need the cross-utilities
+on ftp.ecs.soton.ac.uk in the /pub/armlinux/cross-compilers
+subdirectory.
+
+To configure the kernel, edit the top-level makefile, replacing:
+ARCH = i386 with ARCH = arm
+
+Then examine arch/arm/Makefile for sub-architecture options
+(including processor and machine type), setting them as required.
+
+Do a make config, followed by a make dep, and finally a make all.
+
+Please send all patches, bug reports and code for the ARM Linux
+project to rmk92@ecs.soton.ac.uk.  Patches will not be included
+into future kernels unless they come to me (or the relevent
+person concerned).
+
+Here is a list of people currently working on the project (If you
+wish to be added to the list, please mail me):
+
+Name: Russell King
+Mail: rmk92@ecs.soton.ac.uk
+Desc: Origional developer of ARM Linux, A5000 code and project
+      co-ordinator.
+
+Name: Dave Gilbert
+Mail: gilbertd@cs.man.ac.uk
+Desc: A3/4/5xx floppy and hard disk code maintainer.
+
+Name: Ian Jeffray
+Mail: ian_jeffray@MENTORG.COM
+Desc: A3/4/5xx serial and parrallel port code maintainer.
diff -urN linux.store/linux/arch/arm/Makefile linux/arch/arm/Makefile
--- linux.store/linux/arch/arm/Makefile	Sat Feb 24 13:08:03 1996
+++ linux/arch/arm/Makefile	Wed Mar 13 22:55:58 1996
@@ -10,38 +10,68 @@
 # License.  See the file "COPYING" in the main directory of this archive
 # for more details.
 #
-# Copyright (C) 1995 by Russell King
+# Copyright (C) 1995, 1996 by Russell King
 #
-
-#
-# Set these to indicate how to link it..
-# -qmagic (we need to remove the 32 byte header for bootup purposes)
+# Since we are going multi-computer, I think that this ought to reflect it...
 #
+# THIS IS MY PATCHLEVEL:  PATCHLEVEL2
+
+# MACHINE can be: arc a5k rpc
+# PROCESSOR can be: arm2 arm3 arm6
+# Computer:	MACHINE:  PROCESSOR:
+#  A3xx		arc	  arm2
+#  A4xx		arc	  arm2
+#  A5xx		arc	  arm2
+#  A5000	a5k	  arm3
+#  A4000	a5k	  arm3
+#  A3020	a5k	  arm3 (ok)
 
-SUBARCH		 = -m3
+MACHINE		 = a5k
+PROCESSOR	 = arm3
 
 CPP		 = $(CC) -E $(SUBARCH)
-CFLAGS		:= $(CFLAGS:-fomit-frame-pointer=) $(SUBARCH)
+HOSTCFLAGS	:= $(CFLAGS:-fomit-frame-pointer=)
+CFLAGS		:= $(CFLAGS:-fomit-frame-pointer=) $(ARCHFLAGS)
 LINKFLAGS	 = -Ttext 0x01800000
 ZLINKFLAGS	 = -N -Ttext 0x01800000
+GCCLIB		:= `gcc --print-libgcc-file-name`
+
+# -------------------------- END OF USER CONFIGURATION ------------------------------
+
+ifeq ($(PROCESSOR),arm3)
+ARCHFLAGS	 = -m3
+else
+ifeq ($(PROCESSOR),arm2)
+ARCHFLAGS	 = -m2
+else
+ARCHFLAGS	 =
+endif
+endif
+
+ifeq ($(MACHINE),a5k)
+ARCHFLAGS	:= $(ARCHFLAGS) -DCONFIG_ARCH_A5K
+else
+ifeq ($(MACHINE),arc)
+ARCHFLAGS	:= $(ARCHFLAGS) -DCONFIG_ARCH_ARC
+endif
+endif
 
 HEAD		:= arch/arm/kernel/head.o
 SUBDIRS		:= arch/arm/drivers arch/arm/kernel arch/arm/mm arch/arm/lib $(SUBDIRS)
 ARCHIVES	:= arch/arm/kernel/kernel.o arch/arm/mm/mm.o arch/arm/lib/lib.o $(ARCHIVES)
-LIBS		:= $(LIBS) `gcc --print-libgcc-file-name`
+LIBS		:= $(LIBS) $(GCCLIB)
 
-DRIVERS := arch/arm/drivers/block/block.a arch/arm/drivers/char/char.a \
-           arch/arm/drivers/net/net.a
+DRIVERS		:= arch/arm/drivers/block/block.a arch/arm/drivers/char/char.a \
+	           arch/arm/drivers/net/net.a
 
 ifdef CONFIG_SOUND
-DRIVERS := $(DRIVERS) arch/arm/drivers/sound/sound.a
+DRIVERS		:= $(DRIVERS) arch/arm/drivers/sound/sound.a
 endif
 
 ifdef CONFIG_SCSI
-DRIVERS := $(DRIVERS) arch/arm/drivers/scsi/scsi.a
+DRIVERS		:= $(DRIVERS) arch/arm/drivers/scsi/scsi.a
 endif
 
-
 arch/arm/kernel: dummy
 	$(MAKE) linuxsubdirs SUBDIRS=arch/arm/kernel
 
@@ -50,6 +80,10 @@
 
 MAKEBOOT = $(MAKE) -C arch/$(ARCH)/boot
 
+symlinks::
+	rm -f include/asm-arm/arch include/asm-arm/proc
+	(cd include/asm-arm; ln -sf arch-$(MACHINE) arch; ln -sf proc-$(PROCESSOR) proc)
+
 install:
 	@$(MAKEBOOT) install
 
@@ -65,6 +99,7 @@
 	@$(MAKE) -C arch/$(ARCH)/drivers/char LINKCLEAN
 	@$(MAKE) -C arch/$(ARCH)/drivers/net LINKCLEAN
 	@$(MAKE) -C arch/$(ARCH)/drivers/scsi LINKCLEAN
+	rm -f include/asm-arm/arch include/asm-arm/proc
 
 archdep:
 	@$(MAKEBOOT) dep
diff -urN linux.store/linux/arch/arm/boot/Makefile linux/arch/arm/boot/Makefile
--- linux.store/linux/arch/arm/boot/Makefile	Sun Feb 11 21:59:54 1996
+++ linux/arch/arm/boot/Makefile	Mon Mar 11 20:46:17 1996
@@ -1,11 +1,11 @@
 #
-# arch/i386/boot/Makefile
+# arch/arm/boot/Makefile
 #
 # This file is subject to the terms and conditions of the GNU General Public
 # License.  See the file "COPYING" in the main directory of this archive
 # for more details.
 #
-# Copyright (C) 1994 by Linus Torvalds
+# Copyright (C) 1995, 1996 Russell King
 #
 
 Image:	$(CONFIGURE) tools/build $(TOPDIR)/vmlinux
@@ -25,23 +25,10 @@
 	sh ./install.sh $(VERSION).$(PATCHLEVEL).$(SUBLEVEL) zImage $(TOPDIR)/System.map "$(INSTALL_PATH)"
 
 tools/build: tools/build.c
-	$(HOSTCC) $(CFLAGS) -o $@ $< -I$(TOPDIR)/include
+	$(HOSTCC) $(HOSTCFLAGS) -o $@ $< -I$(TOPDIR)/include
 
 clean:
 	rm -f Image zImage tools/build
 	@$(MAKE) -C compressed clean
 
 dep:
-
-#zdisk: zImage
-#	dd bs=8192 if=zImage of=/dev/fd0
-
-#zlilo: $(CONFIGURE) zImage
-#	if [ -f $(INSTALL_PATH)/vmlinuz ]; then mv $(INSTALL_PATH)/vmlinuz $(INSTALL_PATH)/vmlinuz.old; fi
-#	if [ -f $(INSTALL_PATH)/System.map ]; then mv $(INSTALL_PATH)/System.map $(INSTALL_PATH)/System.old; fi
-#	cat zImage > $(INSTALL_PATH)/vmlinuz
-#	cp $(TOPDIR)/System.map $(INSTALL_PATH)/
-#	if [ -x /sbin/lilo ]; then /sbin/lilo; else /etc/lilo/install; fi
-
-#install: $(CONFIGURE) zImage
-#	sh ./install.sh $(VERSION).$(PATCHLEVEL).$(SUBLEVEL) zImage $(TOPDIR)/System.map "$(INSTALL_PATH)"
diff -urN linux.store/linux/arch/arm/boot/compressed/Makefile linux/arch/arm/boot/compressed/Makefile
--- linux.store/linux/arch/arm/boot/compressed/Makefile	Sun Mar  3 13:35:37 1996
+++ linux/arch/arm/boot/compressed/Makefile	Mon Mar 11 20:58:20 1996
@@ -7,6 +7,7 @@
 CFLAGS = -O2 -DSTDC_HEADERS
 LOADADDR = 0x01800000
 RELADDR = 0x01960000
+ARFLAGS = rcv
 
 SYSTEM = $(TOPDIR)/vmlinux
 DECOMP_OBJS = inflate.o unzip.o misc.o ../../lib/ll_char_wr.o
@@ -45,10 +46,10 @@
 # rules for extracting & piggybacking the kernel
 
 xtract: 	xtract.c
-		$(HOSTCC) $(CFLAGS) -o xtract xtract.c
+		$(HOSTCC) $(HOSTCFLAGS) -o xtract xtract.c
 
 piggyback:	piggyback.c
-		$(HOSTCC) $(CFLAGS) -o piggyback piggyback.c
+		$(HOSTCC) $(HOSTCFLAGS) -o piggyback piggyback.c
 
 
 clean:
diff -urN linux.store/linux/arch/arm/boot/compressed/misc.c linux/arch/arm/boot/compressed/misc.c
--- linux.store/linux/arch/arm/boot/compressed/misc.c	Sun Feb 11 09:32:12 1996
+++ linux/arch/arm/boot/compressed/misc.c	Sun Mar 10 15:32:20 1996
@@ -231,15 +231,15 @@
 
 static void puts(const char *s)
 {
-	extern void ll_char_write(char *, char, char, char, char);
+	extern void ll_write_char(char *, unsigned long);
 	int x,y;
-	char c;
+	unsigned char c;
 	char *ptr;
 
 	x = params->video_x;
 	y = params->video_y;
 
-	while ( ( c = *s++ ) != '\0' ) {
+	while ( ( c = *(unsigned char *)s++ ) != '\0' ) {
 		if ( c == '\n' ) {
 			x = 0;
 			if ( ++y >= video_num_lines ) {
@@ -248,7 +248,7 @@
 			}
 		} else {
 			ptr = vidmem + (y*video_num_columns*params->bytes_per_char_v+x)*bytes_per_char_h;
-			ll_char_write(ptr, c, white, 0, 0);
+			ll_write_char (ptr, c|(white<<8));
 			if ( ++x >= video_num_columns ) {
 				x = 0;
 				if ( ++y >= video_num_lines ) {
diff -urN linux.store/linux/arch/arm/config.in linux/arch/arm/config.in
--- linux.store/linux/arch/arm/config.in	Sat Feb 24 21:32:58 1996
+++ linux/arch/arm/config.in	Wed Mar 13 22:24:44 1996
@@ -18,21 +18,14 @@
 
 mainmenu_option next_comment
 comment 'General setup'
-bool 'Compile for arm3' CONFIG_ARM3 y
-if [ "$CONFIG_ARM3" = "n" ]; then
-  bool 'Compile for arm610/710' CONFIG_ARM610 y
-  if [ "$CONFIG_ARM610" = "n" ]; then
-    bool 'Compile for StrongARM' CONFIG_ARMSTRONG y
-  fi
-else
-  bool 'Page size as 32K' CONFIG_PAGE_32K y
-  if [ "$CONFIG_PAGE_32K" = "n" ]; then
-    bool 'Page size as 16K' CONFIG_PAGE_16K y
-    if [ "$CONFIG_PAGE_16K" = "n" ]; then
-      echo "Auto detected page size"
-    fi
-  fi
-fi
+# Other page sizes aren't supported yet...
+#bool 'Page size as 32K' CONFIG_PAGE_32K y
+#if [ "$CONFIG_PAGE_32K" = "n" ]; then
+#  bool 'Page size as 16K' CONFIG_PAGE_16K y
+#  if [ "$CONFIG_PAGE_16K" = "n" ]; then
+#    echo "Auto detected page size"
+#  fi
+#fi
 
 comment 'Math emulation is provided by a run-time loadable module'
 
@@ -51,6 +44,9 @@
 #  fi
 fi
 tristate 'MFM harddisk support' CONFIG_BLK_DEV_XD n
+if [ "$CONFIG_BLK_DEV_XD" != "n" ]; then
+  bool '  Use MFM with motherboard controller?' CONFIG_MFM_ONMAINBOARD y
+fi
 
 bool 'Networking support' CONFIG_NET y
 bool 'Limit memory to low 16MB' CONFIG_MAX_16M n
diff -urN linux.store/linux/arch/arm/drivers/block/Makefile linux/arch/arm/drivers/block/Makefile
--- linux.store/linux/arch/arm/drivers/block/Makefile	Sat Feb 24 13:17:05 1996
+++ linux/arch/arm/drivers/block/Makefile	Wed Mar 13 14:46:03 1996
@@ -16,27 +16,37 @@
 M_OBJS   :=
 MOD_LIST_NAME := BLOCK_MODULES
 
-ifeq ($(CONFIG_BLK_DEV_FD),y)
-L_OBJS += floppy.o
-else
-  ifeq ($(CONFIG_BLK_DEV_FD),m)
-  M_OBJS += floppy.o
-  endif
+# Architecture dependencies
+
+ifeq ($(MACHINE),a5k)
+  FLOPPY = floppy.o
 endif
 
-ifeq ($(CONFIG_BLK_DEV_HD),y)
-L_OBJS += hd.o
+ifeq ($(MACHINE),arc)
+  FLOPPY = fd1772.o
 endif
 
-ifeq ($(CONFIG_BLK_DEV_IDE),y)
-L_OBJS += ide.o
+# Common dependencies
+
+ifdef FLOPPY
+  ifeq ($(CONFIG_BLK_DEV_FD),y)
+    L_OBJS += $(FLOPPY)
+  else
+    ifeq ($(CONFIG_BLK_DEV_FD),m)
+      M_OBJS += $(FLOPPY)
+    endif
+  endif
+endif
+
+ifeq ($(CONFIG_BLK_DEV_HD),y)
+  L_OBJS += hd.o
 endif
 
-ifeq ($(CONFIG_BLK_DEV_MFM),y)
-L_OBJS += mfmhd.o
+ifeq ($(CONFIG_BLK_DEV_XD),y)
+  L_OBJS += mfmhd.o
 else
-  ifeq ($(CONFIG_BLK_DEV_MFM),m)
-  M_OBJS += mfmhd_mod.o
+  ifeq ($(CONFIG_BLK_DEV_XD),m)
+    M_OBJS += mfmhd_mod.o
   endif
 endif
 
@@ -45,9 +55,9 @@
 fastdep: links
 
 mfmhd_mod.o: mfmhd.o
-	ld -r -o $@ mfmhd.o `gcc --print-libgcc-file-name`
+	ld -r -o $@ mfmhd.o $(GCCLIB)
 
-LK = blk.h ll_rw_blk.c ramdisk.c README.fd README.hd
+LK = blk.h ramdisk.c README.fd README.hd
 
 links:
 	-@for f in $(LK); do \
